Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | Directories | File List | Namespace Members | Class Members | File Members | Related Pages

# Ogre::LogManager Class Reference

The log manager handles the creation and retrieval of logs for the application. More...

`#include <OgreLogManager.h>`

Inheritance diagram for Ogre::LogManager:

[legend]
List of all members.

## Public Member Functions
OGRE_AUTO_MUTEX | LogManager ()
| ~LogManager ()
Log * | createLog (const String &name, bool defaultLog=false, bool debuggerOutput=true, bool suppressFileOutput=false)
| Creates a new log with the given name.
Log * | getLog (const String &name)
| Retrieves a log managed by this class.
Log * | getDefaultLog ()
| Returns a pointer to the default log.
void | destroyLog (const String &name)
| Closes and removes a named log.
void | destroyLog (Log *log)
| Closes and removes a log.
Log * | setDefaultLog (Log *newLog)
| Sets the passed in log as the default log.
void | logMessage (const String &message, LogMessageLevel lml=LML_NORMAL, bool maskDebug=false)
| Log a message to the default log.
void | logMessage (LogMessageLevel lml, const String &message, bool maskDebug=false)
| Log a message to the default log (signature for backward compatibility).
void | setLogDetail (LoggingLevel ll)
| Sets the level of detail of the default log.
## Static Public Member Functions
static LogManager & | getSingleton (void)
| Override standard Singleton retrieval.
static LogManager * | getSingletonPtr (void)
| Override standard Singleton retrieval.
## Protected Types
typedef std::map< String, Log *, std::less< String > > | LogList
## Protected Attributes
LogList | mLogs
| A list of all the logs the manager can access.
Log * | mDefaultLog
| The default log to which output is done.
## Static Protected Attributes
static LogManager * | ms_Singleton

## Detailed Description

The log manager handles the creation and retrieval of logs for the application.

Remarks:
  This class will create new log files and will retrieve instances of existing ones. Other classes wishing to log output can either create a fresh log or retrieve an existing one to output to. One log is the default log, and is the one written to when the logging methods of this class are called.

  By default, Root will instantiate a LogManager (which becomes the Singleton instance) on construction, and will create a default log based on the Root construction parameters. If you want more control, for example redirecting log output right from the start or suppressing debug output, you need to create a LogManager yourself before creating a Root instance, then create a default log. Root will detect that you've created one yourself and won't create one of its own, thus using all your logging preferences from the first instance.

Definition at line 59 of file OgreLogManager.h.

## Member Typedef Documentation

typedef std::map<String, Log*, std::less<String> > Ogre::LogManager::LogList`[protected]`

| Definition at line 62 of file OgreLogManager.h.

## Constructor & Destructor Documentation

OGRE_AUTO_MUTEX Ogre::LogManager::LogManager | ( |  | ) |

Ogre::LogManager::~LogManager | ( |  | ) |

## Member Function Documentation

Log* Ogre::LogManager::createLog | ( | const String & | name,
|  | bool | defaultLog = `false`,
|  | bool | debuggerOutput = `true`,
|  | bool | suppressFileOutput = `false`
| ) |

  | Creates a new log with the given name. Parameters:
  | name | The name to give the log e.g. 'Ogre.log'
  | defaultLog | If true, this is the default log output will be sent to if the generic logging methods on this class are used. The first log created is always the default log unless this parameter is set.
  | debuggerOutput | If true, output to this log will also be routed to the debugger's output window.
  | suppressFileOutput | If true, this is a logical rather than a physical log and no file output will be written. If you do this you should register a LogListener so log output is not lost.

void Ogre::LogManager::destroyLog | ( | Log * | log | ) |

| Closes and removes a log.

void Ogre::LogManager::destroyLog | ( | const String & | name | ) |

| Closes and removes a named log.

Log* Ogre::LogManager::getDefaultLog | ( |  | ) |

| Returns a pointer to the default log.

Log* Ogre::LogManager::getLog | ( | const String & | name | ) |

| Retrieves a log managed by this class.

static LogManager& Ogre::LogManager::getSingleton | ( | void |  | ) | `[static]`

| Override standard Singleton retrieval. Remarks: Why do we do this? Well, it's because the Singleton implementation is in a .h file, which means it gets compiled into anybody who includes it. This is needed for the Singleton template to work, but we actually only want it compiled into the implementation of the class based on the Singleton, not all of them. If we don't change this, we get link errors when trying to use the Singleton-based class from an outside dll. This method just delegates to the template version anyway, but the implementation stays in this single compilation unit, preventing link errors. Reimplemented from Ogre::Singleton< LogManager >.

static LogManager* Ogre::LogManager::getSingletonPtr | ( | void |  | ) | `[static]`

| Override standard Singleton retrieval. Remarks: Why do we do this? Well, it's because the Singleton implementation is in a .h file, which means it gets compiled into anybody who includes it. This is needed for the Singleton template to work, but we actually only want it compiled into the implementation of the class based on the Singleton, not all of them. If we don't change this, we get link errors when trying to use the Singleton-based class from an outside dll. This method just delegates to the template version anyway, but the implementation stays in this single compilation unit, preventing link errors. Reimplemented from Ogre::Singleton< LogManager >.

void Ogre::LogManager::logMessage | ( | LogMessageLevel | lml,
|  | const String & | message,
|  | bool | maskDebug = `false`
| ) |

| Log a message to the default log (signature for backward compatibility). Definition at line 120 of file OgreLogManager.h.

void Ogre::LogManager::logMessage | ( | const String & | message,
|  | LogMessageLevel | lml = `LML_NORMAL`,
|  | bool | maskDebug = `false`
| ) |

| Log a message to the default log.

Log* Ogre::LogManager::setDefaultLog | ( | Log * | newLog | ) |

| Sets the passed in log as the default log. Returns: The previous default log.

void Ogre::LogManager::setLogDetail | ( | LoggingLevel | ll | ) |

| Sets the level of detail of the default log.

## Member Data Documentation

Log* Ogre::LogManager::mDefaultLog`[protected]`

| The default log to which output is done. Definition at line 68 of file OgreLogManager.h.

LogList Ogre::LogManager::mLogs`[protected]`

| A list of all the logs the manager can access. Definition at line 65 of file OgreLogManager.h.

LogManager * Ogre::Singleton< LogManager >::ms_Singleton`[static, protected, inherited]`

| Definition at line 61 of file OgreSingleton.h.

The documentation for this class was generated from the following file:

- OgreLogManager.h

Copyright © 2000-2005 by The OGRE Team
This work is licensed under a Creative Commons Attribution-ShareAlike 2.5 License.
Last modified Thu Mar 6 09:47:01 2008